| Kea 3.0.3-git

isc::data::StringElement Class Reference

`#include <data.h>`

Inheritance diagram for isc::data::StringElement:
[legend]

## Public Member Functions
| StringElement (std::string v, const Position &pos=ZERO_POSITION())
bool | equals (const Element &other, unsigned level=MAX_NESTING_LEVEL) const
| Test equality.
virtual bool | getValue (bool &t) const
| Get the boolean value.
virtual bool | getValue (double &t) const
| Get the double value.
virtual bool | getValue (int64_t &t) const
| Get the integer value.
virtual bool | getValue (std::map< std::string, ConstElementPtr > &t) const
| Get the map value.
bool | getValue (std::string &t) const
| Get the string value.
virtual bool | getValue (std::vector< ElementPtr > &t) const
| Get the list value.
virtual bool | setValue (const bool t)
| Set the boolean value.
virtual bool | setValue (const double v)
| Set the double value.
bool | setValue (const int i)
| Set the integer value (int overload).
virtual bool | setValue (const isc::util::int128_t &v)
| Set the big integer value.
bool | setValue (const long int i)
| Set the integer value (long int overload).
virtual bool | setValue (const long long int v)
| Set the integer value.
virtual bool | setValue (const std::map< std::string, ConstElementPtr > &v)
| Set the map value.
bool | setValue (const std::string &v)
| Set the string value.
virtual bool | setValue (const std::vector< ElementPtr > &v)
| Set the list value.
std::string | stringValue () const
| Return the string value.
void | toJSON (std::ostream &ss, unsigned level=MAX_NESTING_LEVEL) const
| Converts the Element to JSON format and appends it to the given output stream.
Public Member Functions inherited from isc::data::Element
virtual | ~Element ()
const Position & | getPosition () const
| Returns position where the data element's value starts in a configuration string.
types | getType () const
std::string | str () const
| Returns a string representing the Element and all its child elements.
std::string | toWire () const
| Returns the wireformat for the Element and all its child elements.
void | toWire (std::ostream &out) const
| Appends the wireformat for the Element to the stream.
virtual int64_t | intValue () const
| Return the integer value.
virtual isc::util::int128_t | bigIntValue () const
| Return the big integer value.
virtual double | doubleValue () const
| Return the double value.
virtual bool | boolValue () const
| Return the boolean value.
virtual const std::vector< ElementPtr > & | listValue () const
| Return the list value.
virtual const std::map< std::string, ConstElementPtr > & | mapValue () const
| Return the map value.
bool | setValue (const long int i)
| Set the integer value (long int overload).
bool | setValue (const int i)
| Set the integer value (int overload).
virtual ConstElementPtr | get (const int i) const
| Returns the ElementPtr at the given index.
virtual ElementPtr | getNonConst (const int i) const
| returns element as non-const pointer.
virtual void | set (const size_t i, ElementPtr element)
| Sets the ElementPtr at the given index.
virtual void | add (ElementPtr element)
| Adds an ElementPtr to the list.
virtual void | remove (const int i)
| Removes the element at the given position.
virtual size_t | size () const
| Returns the number of elements in the list.
virtual bool | empty () const
| Return true if there are no elements in the list.
virtual ConstElementPtr | get (const std::string &name) const
| Returns the ElementPtr at the given key.
virtual void | set (const std::string &name, ConstElementPtr element)
| Sets the ElementPtr at the given key.
virtual void | remove (const std::string &name)
| Remove the ElementPtr at the given key.
virtual bool | contains (const std::string &name) const
| Checks if there is data at the given key.
virtual ConstElementPtr | find (const std::string &identifier) const
| Recursively finds any data at the given identifier.
virtual bool | find (const std::string &identifier, ConstElementPtr &t) const
| See `Element::find()`.
void | removeEmptyContainersRecursively (unsigned level=MAX_NESTING_LEVEL)
| Remove all empty maps and lists from this Element and its descendants.

## Additional Inherited Members
Public Types inherited from isc::data::Element
enum | types : int { integer = 0 , real = 1 , boolean = 2 , null = 3 , string = 4 , bigint = 5 , list = 6 , map = 7 , any = 8 }
| The types that an Element can hold. More...
Static Public Member Functions inherited from isc::data::Element
static const Position & | ZERO_POSITION ()
| Returns `Position` object with line_ and pos_ set to 0, and with an empty file name.
static ElementPtr | create (const Position &pos=ZERO_POSITION())
| Create a NullElement.
static ElementPtr | create (const long long int i, const Position &pos=ZERO_POSITION())
| Create an IntElement.
static ElementPtr | create (const int i, const Position &pos=ZERO_POSITION())
| Create an IntElement (int overload).
static ElementPtr | create (const long int i, const Position &pos=ZERO_POSITION())
| Create an IntElement (long int overload).
static ElementPtr | create (const uint32_t i, const Position &pos=ZERO_POSITION())
| Create an IntElement (int32_t overload).
static ElementPtr | create (const isc::util::int128_t &i, const Position &pos=ZERO_POSITION())
| Create a BigIntElement.
static ElementPtr | create (const double d, const Position &pos=ZERO_POSITION())
| Create a DoubleElement.
static ElementPtr | create (const bool b, const Position &pos=ZERO_POSITION())
| Create a BoolElement.
static ElementPtr | create (const std::string &s, const Position &pos=ZERO_POSITION())
| Create a StringElement.
static ElementPtr | create (const char *s, const Position &pos=ZERO_POSITION())
| Create a StringElement (char* overload).
static ElementPtr | createList (const Position &pos=ZERO_POSITION())
| Creates an empty ListElement type ElementPtr.
static ElementPtr | createMap (const Position &pos=ZERO_POSITION())
| Creates an empty MapElement type ElementPtr.
static ElementPtr | fromJSON (const std::string &in, bool preproc=false)
| These functions will parse the given string (JSON) representation of a compound element.
static ElementPtr | fromJSON (std::istream &in, bool preproc=false)
| Creates an Element from the given input stream containing JSON formatted data.
static ElementPtr | fromJSON (std::istream &in, const std::string &file_name, bool preproc=false)
| Creates an Element from the given input stream containing JSON formatted data.
static ElementPtr | fromJSON (std::istream &in, const std::string &file, int &line, int &pos, unsigned level=MAX_NESTING_LEVEL)
| Creates an Element from the given input stream, where we keep track of the location in the stream for error reporting.
static ElementPtr | fromJSONFile (const std::string &file_name, bool preproc=false)
| Reads contents of specified file and interprets it as JSON.
static std::string | typeToName (Element::types type)
| Returns the name of the given type as a string.
static Element::types | nameToType (const std::string &type_name)
| Converts the string to the corresponding type Throws a TypeError if the name is unknown.
static void | preprocess (std::istream &in, std::stringstream &out)
| input text preprocessor.
static ElementPtr | fromWire (std::stringstream &in, int length)
| These function parse the wireformat at the given stringstream (of the given length).
static ElementPtr | fromWire (const std::string &s)
| Creates an Element from the wire format in the given string.
Static Public Attributes inherited from isc::data::Element
static constexpr unsigned | MAX_NESTING_LEVEL = 100U
| Maximum nesting level of Element objects.
Protected Member Functions inherited from isc::data::Element
| Element (types t, const Position &pos=ZERO_POSITION())
| Constructor.

## Detailed Description

Definition at line 885 of file data.h.

## Constructor & Destructor Documentation

## ◆ StringElement()

isc::data::StringElement::StringElement | ( | std::string | v,
|  | const Position & | pos = ZERO_POSITION() )
| inline

Definition at line 889 of file data.h.

References isc::data::Element::Element(), and isc::data::Element::string.

Here is the call graph for this function:

## Member Function Documentation

## ◆ equals()

bool isc::data::StringElement::equals | ( | const Element & | other,
|  | unsigned | level = MAX_NESTING_LEVEL ) const
| virtual

Test equality.

Parameters

  other | The other element to compare with.
  level | The maximum level of recursion.

Returns
  true if the other ElementPtr has the same value and the same type (or a different and compatible type), false otherwise.

Exceptions

  BadValue | when nesting depth is more than level.

Implements isc::data::Element.

Definition at line 1135 of file data.cc.

References isc::data::Element::Element(), isc::data::Element::getType(), isc::data::Element::string, and isc::data::Element::stringValue().

Here is the call graph for this function:

## ◆ getValue() [1/6]

bool isc::data::Element::getValue | ( | bool & | t | ) | const
| virtual

Get the boolean value.

Parameters

  t | The reference to the boolean.

Returns
  false.

Reimplemented from isc::data::Element.

Definition at line 337 of file data.cc.

## ◆ getValue() [2/6]

bool isc::data::Element::getValue | ( | double & | t | ) | const
| virtual

Get the double value.

Parameters

  t | The reference to the double.

Returns
  false.

Reimplemented from isc::data::Element.

Definition at line 331 of file data.cc.

## ◆ getValue() [3/6]

bool isc::data::Element::getValue | ( | int64_t & | t | ) | const
| virtual

Get the integer value.

Parameters

  t | The reference to the integer.

Returns
  false.

Reimplemented from isc::data::Element.

Definition at line 325 of file data.cc.

## ◆ getValue() [4/6]

bool isc::data::Element::getValue | ( | std::map< std::string, ConstElementPtr > & | t | ) | const
| virtual

Get the map value.

Parameters

  t | The reference to the map.

Returns
  false.

Reimplemented from isc::data::Element.

Definition at line 355 of file data.cc.

## ◆ getValue() [5/6]

bool isc::data::StringElement::getValue | ( | std::string & | t | ) | const
| inline virtual

Get the string value.

Parameters

  t | The reference to the string.

Returns
  false.

Reimplemented from isc::data::Element.

Definition at line 893 of file data.h.

## ◆ getValue() [6/6]

bool isc::data::Element::getValue | ( | std::vector< ElementPtr > & | t | ) | const
| virtual

Get the list value.

Parameters

  t | The reference to the list.

Returns
  false.

Reimplemented from isc::data::Element.

Definition at line 349 of file data.cc.

## ◆ setValue() [1/9]

bool isc::data::Element::setValue | ( | const bool | t | ) |
| virtual

Set the boolean value.

Parameters

  t | The new boolean value.

Returns
  False.

Reimplemented from isc::data::Element.

Definition at line 390 of file data.cc.

## ◆ setValue() [2/9]

bool isc::data::Element::setValue | ( | const double | v | ) |
| virtual

Set the double value.

Parameters

  v | The new double value.

Returns
  False.

Reimplemented from isc::data::Element.

Definition at line 384 of file data.cc.

## ◆ setValue() [3/9]

bool isc::data::Element::setValue | ( | const int | i | ) |
| inline

Set the integer value (int overload).

Parameters

  i | The new integer value.

Returns
  True (and set the value) when the Element type is integer, false otherwise.

Definition at line 424 of file data.h.

## ◆ setValue() [4/9]

bool isc::data::Element::setValue | ( | const isc::util::int128_t & | v | ) |
| virtual

Set the big integer value.

Parameters

  v | The new big integer value.

Returns
  False.

Reimplemented from isc::data::Element.

Definition at line 378 of file data.cc.

## ◆ setValue() [5/9]

bool isc::data::Element::setValue | ( | const long int | i | ) |
| inline

Set the integer value (long int overload).

Parameters

  i | The new integer value.

Returns
  True (and set the value) when the Element type is integer, false otherwise.

Definition at line 415 of file data.h.

## ◆ setValue() [6/9]

bool isc::data::Element::setValue | ( | const long long int | v | ) |
| virtual

Set the integer value.

Parameters

  v | The new integer value.

Returns
  False.

Reimplemented from isc::data::Element.

Definition at line 372 of file data.cc.

## ◆ setValue() [7/9]

bool isc::data::Element::setValue | ( | const std::map< std::string, ConstElementPtr > & | v | ) |
| virtual

Set the map value.

Parameters

  v | The new map value.

Returns
  False.

Reimplemented from isc::data::Element.

Definition at line 408 of file data.cc.

## ◆ setValue() [8/9]

bool isc::data::StringElement::setValue | ( | const std::string & | v | ) |
| inline virtual

Set the string value.

Parameters

  v | The new string value.

Returns
  False.

Reimplemented from isc::data::Element.

Definition at line 895 of file data.h.

## ◆ setValue() [9/9]

bool isc::data::Element::setValue | ( | const std::vector< ElementPtr > & | v | ) |
| virtual

Set the list value.

Parameters

  v | The new list value.

Returns
  False.

Reimplemented from isc::data::Element.

Definition at line 402 of file data.cc.

## ◆ stringValue()

std::string isc::data::StringElement::stringValue | ( |  | ) | const
| inline virtual

Return the string value.

Reimplemented from isc::data::Element.

Definition at line 891 of file data.h.

## ◆ toJSON()

void isc::data::StringElement::toJSON | ( | std::ostream & | ss,
|  | unsigned | level = MAX_NESTING_LEVEL ) const
| virtual

Converts the Element to JSON format and appends it to the given output stream.

Parameters

  ss | The output stream where to append the JSON format.
  level | The maximum level of recursion.

Exceptions

  BadValue | when nesting depth is more than level.

Implements isc::data::Element.

Definition at line 935 of file data.cc.

References isc::data::Element::str(), and isc::data::Element::stringValue().

Here is the call graph for this function:

The documentation for this class was generated from the following files:

- data.h
- data.cc